# -*- coding: utf-8 -*-
"""
Created on Tue Feb 23 18:12:11 2021

@author: Johannes Neumeyer
"""

from random import randint
from graphics_and_games_klassen import Rechteck, Figur, Ereignisbehandlung

class Fisch(Figur):
    """
    Oberklasse aller Fische
    """

    def __init__(self, xstart, ausgangshoehe):
        """
        Belegt die Startposition
        -- Parameter xstart Startposition waagrecht
        -- Parameter ausgangshoehe Schwimmhoehe zu Beginn
        """
        super().__init__()
        #  Schwimmhoehe
        self.hoehe = ausgangshoehe
        #  Position waagrecht
        self.x = xstart
        self.blickrichtung = 'l'
        self.PositionSetzen(self.x, self.hoehe)

    def FigurRechtsBlickendSetzen(self):
        """
        Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
        """

    def FigurLinksBlickendSetzen(self):
        """
        Erzeugt die nach links blickende Figur und setzt die Blickrichtung
        """

    def Schwimmen(self):
        """
        Bewegt den Fisch
        """
        if self.blickrichtung == 'l':
            if self.x < 100:
                self.FigurRechtsBlickendSetzen()
                self.x = self.x + 100
            else:
                self.x = self.x - 100
        else:
            if self.x > 700:
                self.FigurLinksBlickendSetzen()
                self.x = self.x - 100
            else:
                self.x = self.x + 100
        self.PositionSetzen(self.x, self.hoehe)

class Clownfisch(Fisch):
    """
    Beschreibt einen Clownfisch
    """

    def __init__(self, xstart, ausgangshoehe):
        """
        Belegt die Startposition
        -- Parameter xstart Startposition waagrecht
        -- Parameter ausgangshoehe Schwimmhoehe zu Beginn
        """
        super().__init__(xstart, ausgangshoehe)
        self.FigurLinksBlickendSetzen()

    def FigurRechtsBlickendSetzen(self):
        """
        Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
        """
        self.blickrichtung = 'r'
        self.EigeneFigurLoeschen()
        #  Schwanz
        self.FigurteilFestlegenDreieck(-50, -10, -50, 20, -40, -20, "orange")
        self.FigurteilFestlegenDreieck(-40, -20, -50, 20, -40, 30, "orange")
        self.FigurteilFestlegenDreieck(-40, -20, -40, 30, -30, 0, "weiss")
        self.FigurteilFestlegenDreieck(-30, 0, -40, 30, -30, 10, "orange")
        #  Koerper
        self.FigurteilFestlegenDreieck(0, -40, -20, -30, -30, 0, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -30, 0, -30, 10, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -30, 10, -20, 30, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -20, 30, 10, 30, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 10, 30, 40, 20, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 40, 20, 50, 0, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 50, 0, 50, -10, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 50, -10, 20, -40, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -20, 0, -10, 30, "weiss")
        self.FigurteilFestlegenDreieck(30, -30, 10, -10, 10, 30, "weiss")
        #  Auge
        self.FigurteilFestlegenEllipse(25, -35, 30, 30, "weiss")
        self.FigurteilFestlegenEllipse(40, -20, 10, 10, "blau")

    def FigurLinksBlickendSetzen(self):
        """
        Erzeugt die nach links blickende Figur und setzt die Blickrichtung
        """
        self.blickrichtung = 'l'
        self.EigeneFigurLoeschen()
        #  Schwanz
        self.FigurteilFestlegenDreieck(50, -10, 50, 20, 40, -20, "orange")
        self.FigurteilFestlegenDreieck(40, -20, 50, 20, 40, 30, "orange")
        self.FigurteilFestlegenDreieck(40, -20, 40, 30, 30, 0, "weiss")
        self.FigurteilFestlegenDreieck(30, 0, 40, 30, 30, 10, "orange")
        #  Koerper
        self.FigurteilFestlegenDreieck(0, -40, 20, -30, 30, 0, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 30, 0, 30, 10, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 30, 10, 20, 30, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 20, 30, -10, 30, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -10, 30, -40, 20, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -40, 20, -50, 0, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -50, 0, -50, -10, "orange")
        self.FigurteilFestlegenDreieck(0, -40, -50, -10, -20, -40, "orange")
        self.FigurteilFestlegenDreieck(0, -40, 20, 0, 10, 30, "weiss")
        self.FigurteilFestlegenDreieck(-30, -30, -10, -10, -10, 30, "weiss")
        #  Auge
        self.FigurteilFestlegenEllipse(-55, -35, 30, 30, "weiss")
        self.FigurteilFestlegenEllipse(-50, -20, 10, 10, "blau")

    def Schwimmen(self):
        """
        Bewegt den Fisch
        """
        if self.blickrichtung == 'l':
            if self.x < 60:
                self.FigurRechtsBlickendSetzen()
                self.x = self.x + 30
                self.hoehe = self.hoehe + 15
            else:
                self.x = self.x - 30
                self.hoehe = self.hoehe - 15
        else:
            if self.x > 730:
                self.FigurLinksBlickendSetzen()
                self.x = self.x - 30
                self.hoehe = self.hoehe - 15
            else:
                self.x = self.x + 30
                self.hoehe = self.hoehe + 15

        if self.hoehe < 5:
            self.hoehe = 5
        elif self.hoehe > 485:
            self.hoehe = 485

        self.PositionSetzen(self.x, self.hoehe)

class Piranha(Fisch):
    """
    Beschreibt einen Piranha
    """

    def __init__(self, xstart, ausgangshoehe):
        """
        Belegt die Startposition
        -- Parameter xstart Startposition waagrecht
        -- Parameter ausgangshoehe Schwimmhoehe zu Beginn
        """
        super().__init__(xstart, ausgangshoehe)
        self.FigurLinksBlickendSetzen()

    def FigurRechtsBlickendSetzen(self):
        """
        Erzeugt die nach rechts blickende Figur und setzt die Blickrichtung
        """
        self.blickrichtung = 'r'
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenDreieck(-50, 50, -40, 0, -20, 0, "grau")
        self.FigurteilFestlegenDreieck(-40, 0, -50, -50, -20, 0, "grau")
        self.FigurteilFestlegenDreieck(-40, 0, -32, 20, -10, 30, "grau")
        #  Afterflosse
        self.FigurteilFestlegenDreieck(-32, 20, -30, 40, -10, 30, "schwarz")
        self.FigurteilFestlegenDreieck(-40, 0, -10, 30, 20, 30, "grau")
        self.FigurteilFestlegenDreieck(-40, 0, 20, 30, 40, 20, "grau")
        #  Bauchflosse
        self.FigurteilFestlegenDreieck(20, 30, 40, 40, 40, 20, "schwarz")
        self.FigurteilFestlegenDreieck(-40, 0, 40, 20, 50, 0, "grau")
        self.FigurteilFestlegenDreieck(-40, 0, 30, 0, 10, -30, "grau")
        #  Rueckenflosse
        self.FigurteilFestlegenDreieck(-10, -50, 30, 0, 50, -20, "grau")
        self.FigurteilFestlegenDreieck(40, -10, 50, -10, 50, -20, "grau")
        self.FigurteilFestlegenEllipse(25, -25, 10, 10, "rot")

    def FigurLinksBlickendSetzen(self):
        """
        Erzeugt die nach links blickende Figur und setzt die Blickrichtung
        """
        self.blickrichtung = 'l'
        self.EigeneFigurLoeschen()
        self.FigurteilFestlegenDreieck(50, 50, 40, 0, 20, 0, "grau")
        self.FigurteilFestlegenDreieck(40, 0, 50, -50, 20, 0, "grau")
        self.FigurteilFestlegenDreieck(40, 0, 32, 20, 10, 30, "grau")
        #  Afterflosse
        self.FigurteilFestlegenDreieck(32, 20, 30, 40, 10, 30, "schwarz")
        self.FigurteilFestlegenDreieck(40, 0, 10, 30, -20, 30, "grau")
        self.FigurteilFestlegenDreieck(40, 0, -20, 30, -40, 20, "grau")
        #  Bauchflosse
        self.FigurteilFestlegenDreieck(-20, 30, -40, 40, -40, 20, "schwarz")
        self.FigurteilFestlegenDreieck(40, 0, -40, 20, -50, 0, "grau")
        self.FigurteilFestlegenDreieck(40, 0, -30, 0, -10, -30, "grau")
        #  Rueckenflosse
        self.FigurteilFestlegenDreieck(10, -50, -30, 0, -50, -20, "grau")
        self.FigurteilFestlegenDreieck(-40, -10, -50, -10, -50, -20, "grau")
        self.FigurteilFestlegenEllipse(-35, -25, 10, 10, "rot")

    def Schwimmen(self):
        """
        Bewegt den Fisch
        """
        if self.blickrichtung == 'l':
            if self.x < 60:
                self.FigurRechtsBlickendSetzen()
                self.x = self.x + 70
                self.hoehe = self.hoehe - 5
            else:
                self.x = self.x - 70
                self.hoehe = self.hoehe + 5
        else:
            if self.x > 730:
                self.FigurLinksBlickendSetzen()
                self.x = self.x - 70
                self.hoehe = self.hoehe + 5
            else:
                self.x = self.x + 70
                self.hoehe = self.hoehe - 5
        if self.hoehe < 5:
            self.hoehe = 5
        elif self.hoehe > 485:
            self.hoehe = 485

        self.PositionSetzen(self.x, self.hoehe)

class Aquarium(Ereignisbehandlung):
    """
    Verwaltet das Aquarium
    """

    def __init__(self):
        """
        Legt die Fische an und startet den Taktgenerator
        """
        super().__init__()
        hintergrund = Rechteck()
        hintergrund.FarbeSetzen("blau")
        hintergrund.PositionSetzen(0, 0)
        hintergrund.GroesseSetzen(800, 510)
        #  Feld der Fische
        self.fische = []
        i = 1
        while i <= 10:
            self.x = 100 + randint(0, 599)
            self.hoehe = 50 + randint(0, 399)

            if randint(0, 99) < 50:
                self.fische.append(Clownfisch(self.x, self.hoehe))
            else:
                self.fische.append(Piranha(self.x, self.hoehe))
            i = i + 1
        self.TaktdauerSetzen(500)
        self.Starten()

    def AktionAusfuehren(self):
        """
        Bewegt alle Fische
        """
        for f in self.fische:
            f.Schwimmen()

a = Aquarium()
